// ----------------------------------------
// Использование органа управления
// класса "listbox"
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>

// Идентификатор списка
#define ID_LIST   1

// Идентификатор кнопки
#define ID_BUTTON 2

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

// Имя класса окна
char const szClassName[]   = "ListBoxAppClass";

// Заголовок окна
char const szWindowTitle[] = "ListBox Demo";

// Идентификатор копии приложения
HINSTANCE hInst;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  // Сохраняем идентификатор копии приложения
  // в глобальной переменной
  hInst = hInstance;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwnd = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем расположение и размеры
    CW_USEDEFAULT,       // окна, принятые по умолчанию
    CW_USEDEFAULT,       // 
    CW_USEDEFAULT,       // 
    0,                   // идентификатор родительского окна
    0,                   // идентификатор меню
    hInstance,           // идентификатор приложения
    NULL);               // указатель на дополнительные
			 // параметры
  // Если создать окно не удалось, завершаем приложение
  if(!hwnd)
    return FALSE;

  // Рисуем главное окно
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  // Идентификатор органа управления "listbox"
  static HWND hListBox;

  // Идентификатор кнопки
  static HWND hButton;

  switch (msg)
  {
    case WM_CREATE:
    {
      // Создаем список
      hListBox = CreateWindow("listbox", NULL,
	 WS_CHILD | WS_VISIBLE | LBS_STANDARD |
         LBS_WANTKEYBOARDINPUT,
	 30, 30, 200, 100,
	 hwnd, (HMENU) ID_LIST, hInst, NULL);

      // Отменяем режим перерисовки списка
      SendMessage(hListBox, WM_SETREDRAW, FALSE, 0L);

      // Добавляем в список несколько строк

      SendMessage(hListBox, LB_ADDSTRING, 0,
        (LPARAM)(LPSTR)"Зеленый");

      SendMessage(hListBox, LB_ADDSTRING, 0,
        (LPARAM)(LPSTR)"Красный");

      SendMessage(hListBox, LB_ADDSTRING, 0,
        (LPARAM)(LPSTR)"Розовый");

      SendMessage(hListBox, LB_ADDSTRING, 0,
        (LPARAM)(LPSTR)"Пурпурный");

      SendMessage(hListBox, LB_ADDSTRING, 0,
	(LPARAM)(LPSTR)"Синий");

      SendMessage(hListBox, LB_ADDSTRING, 0,
	(LPARAM)(LPSTR)"Желтый");

      SendMessage(hListBox, LB_ADDSTRING, 0,
	(LPARAM)(LPSTR)"Фиолетовый");

      SendMessage(hListBox, LB_ADDSTRING, 0,
	(LPARAM)(LPSTR)"Черный");

      SendMessage(hListBox, LB_ADDSTRING, 0,
	(LPARAM)(LPSTR)"Белый");

      // Включаем режим перерисовки списка
      SendMessage(hListBox, WM_SETREDRAW, TRUE, 0L);

      // Перерисовываем список
      InvalidateRect(hListBox, NULL, TRUE);

      // Создаем кнопку
      hButton = CreateWindow("button", "OK",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 250, 30, 50, 20,
	 hwnd, (HMENU) ID_BUTTON, hInst, NULL);

      return 0;
    }

    // Когда главное окно приложения получает
    // фокус ввода, отдаем фокус списку
    case WM_SETFOCUS:
    {
      SetFocus(hListBox);
      return 0;
    }

    case WM_COMMAND:
    {
      // Обработка извещения списка об ошибке
      if(wParam == ID_LIST)
      {
        // Преобразуем к типу unsigned, так как
        // константа LBN_ERRSPACE определена как
        // отрицательное число
	if(HIWORD(lParam) == (unsigned)LBN_ERRSPACE)
	{
	  MessageBox(hwnd, "Мало памяти",
	   szWindowTitle, MB_OK);
	}

        // Если пользователь сделал двойной щелчок
        // по строке списка, выводим эту строку
        // на экран
	else if(HIWORD(lParam) == LBN_DBLCLK)
	{
          int uSelectedItem;
          char Buffer[256];

          // Определяем номер выделенной строки
	  uSelectedItem = (int)SendMessage(hListBox,
	     LB_GETCURSEL, 0, 0L);

          // Если в списке есть выделенная строка,
          // выводим ее на экран 
	  if(uSelectedItem != LB_ERR)
	  {
             // Получаем выделенную строку
	     SendMessage(hListBox, LB_GETTEXT,
	       uSelectedItem, (LPARAM)Buffer);

             // Выводим ее на экран  
	     MessageBox(hwnd, (LPSTR)Buffer, szWindowTitle,
	       MB_OK);  
          }
	}

        // Если пользователь изменил выделенную
        // строку, выводим в окно новую
        // выделенную строку
	else if(HIWORD(lParam) == LBN_SELCHANGE)
	{
          int uSelectedItem, nSize;
          char Buffer[256];
          HDC hdc;

          // Определяем номер новой выделенной строки
	  uSelectedItem = (int)SendMessage(hListBox,
	     LB_GETCURSEL, 0, 0L);

	  if(uSelectedItem != LB_ERR)
	  {
             // Получаем строку
             SendMessage(hListBox, LB_GETTEXT,
	       uSelectedItem, (LPARAM)Buffer);

             // Получаем контекст отображения  
             hdc = GetDC(hwnd);

             // Определяем длину строки
             nSize = lstrlen(Buffer);

             // Очищаем место для вывода строки
             TextOut(hdc, 250, 60,
             (LPSTR)"                         ", 25);

             // Выводим строку
             TextOut(hdc, 250, 60, (LPSTR)Buffer, nSize);

             // Освобождаем контекст отображения
             ReleaseDC(hwnd, hdc);
          }
	}
      }

      // Сообщение от кнопки
      else if(wParam == ID_BUTTON)
      {
	int uSelectedItem;
        char Buffer[256];

        // Определяем номер выделенной строки,
        // получаем текст строки и выводим
        // этот текст в окно
	uSelectedItem = (int)SendMessage(hListBox,
	   LB_GETCURSEL, 0, 0L);

	if(uSelectedItem != LB_ERR)
	{
	   SendMessage(hListBox, LB_GETTEXT,
	     uSelectedItem, (LPARAM)Buffer);

	   MessageBox(hwnd, (LPSTR)Buffer, szWindowTitle,
	     MB_OK);  
        }
      }
      return 0;
    }

    // Это сообщение поступает от списка, если он
    // имеет фокус ввода и пользователь работает
    // с клавиатурой
    case WM_VKEYTOITEM:
    {
      // Если пользователь нажал клавишу <Enter>,
      // посылаем в окно сообщение WM_COMMAND с
      // параметром wParam, равным идентификатору
      // кнопки   
      if(wParam == VK_RETURN)
      {
        SendMessage(hwnd, WM_COMMAND, ID_BUTTON, 0L);
      }
      return -1;
    }

    case WM_PAINT:
    {
      HDC hdc;
      PAINTSTRUCT ps;

      hdc = BeginPaint(hwnd, &ps);

      TextOut(hdc, 30, 10,
	"Выберите цвет и нажмите кнопку 'OK'", 35);

      EndPaint(hwnd, &ps);
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}